-------------------------------------------------
-- Select Map Size
-------------------------------------------------
include( "IconSupport" );

-------------------------------------------------
-------------------------------------------------
function OnBack()
    ContextPtr:SetHide( true );
    ContextPtr:LookUpControl( "../MainSelection" ):SetHide( false );
    ContextPtr:LookUpControl( ".." ):SetHide( false );
end
Controls.BackButton:RegisterCallback( Mouse.eLClick, OnBack );


----------------------------------------------------------------        
-- Input processing
----------------------------------------------------------------        
function InputHandler( uiMsg, wParam, lParam )
    if uiMsg == KeyEvents.KeyDown then
        if wParam == Keys.VK_ESCAPE then
            OnBack();
            return true;
        end
    end
end
ContextPtr:SetInputHandler( InputHandler );


----------------------------------------------------------------        
-- set the size
----------------------------------------------------------------        
function SizeSelected( id )

    if( id == -1 ) then
        PreGame.SetRandomWorldSize( true );
    else
        PreGame.SetRandomWorldSize( false );
        PreGame.SetWorldSize( id );
        PreGame.SetNumMinorCivs( GameInfo.Worlds[ id ].DefaultMinorCivs );
    end
    OnBack();
end


----------------------------------------------------------------        
----------------------------------------------------------------        
function ShowHideHandler( bIsHide )
    if( not bIsHide ) then
        Controls.ScrollPanel:SetScrollValue( 0 );
    end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );


----------------------------------------------------------------        
-- build the buttons
----------------------------------------------------------------        
local controlTable = {};
ContextPtr:BuildInstanceForControl( "ItemInstance", controlTable, Controls.Stack );
IconHookup( 6, 64, "WORLDSIZE_ATLAS", controlTable.Icon );
if(not PreGame.IsMultiplayerGame()) then
	controlTable.Name:SetText( Locale.ConvertTextKey( "TXT_KEY_RANDOM_MAP_SIZE" ) );
	controlTable.Button:SetToolTipString( Locale.ConvertTextKey( "TXT_KEY_RANDOM_MAP_SIZE_HELP" ) );
else
	controlTable.Name:SetText( Locale.ConvertTextKey( "TXT_KEY_ANY_MAP_SIZE" ) );
	controlTable.Button:SetToolTipString( Locale.ConvertTextKey( "TXT_KEY_ANY_MAP_SIZE_HELP" ) );
end

controlTable.Button:SetVoid1( -1 );
controlTable.Button:RegisterCallback( Mouse.eLClick, SizeSelected );

for info in GameInfo.Worlds() do
    local controlTable = {};
    ContextPtr:BuildInstanceForControl( "ItemInstance", controlTable, Controls.Stack );    
    IconHookup( info.PortraitIndex, 64, info.IconAtlas, controlTable.Icon );
    controlTable.Name:SetText( Locale.ConvertTextKey( info.Description ) );
    controlTable.Button:SetToolTipString( Locale.ConvertTextKey( info.Help ) );
    controlTable.Button:SetVoid1( info.ID );
    controlTable.Button:RegisterCallback( Mouse.eLClick, SizeSelected );
end

Controls.Stack:CalculateSize();
Controls.Stack:ReprocessAnchoring();
Controls.ScrollPanel:CalculateInternalSize();